Screen.backgroundColor = "#fff"

leftColor = "Red"
rightColor = "Blue"

mixedColor = Color.mix leftColor, rightColor


# Left color band
color1_layer.backgroundColor = leftColor

# Right color band
color2_layer.backgroundColor = rightColor


# Mixed colors
draggableTop.backgroundColor = mixedColor
draggableBottom.backgroundColor = mixedColor

# Mixed colors are draggable
draggableTop.draggable.enabled = yes
draggableTop.draggable.vertical = no
draggableTop.draggable.constraints = constraintsTop.frame
draggableBottom.draggable.enabled = yes
draggableBottom.draggable.vertical = no
draggableBottom.draggable.constraints = constraintsBottom.frame


# Function for mixing the color of both layers
setMixedColors = (draggedLayer) ->
	
	# Dragging distance between the color bands mapped to 0 > 1 number
	# (can be lower than 0 and higher than 1)
	fraction = Utils.modulate draggedLayer.x, [100, Screen.width-200], [0,1]
	
	# Top layer: Mix the colors WITHOUT transition limit (= default)
	draggableTop.backgroundColor =
		Color.mix leftColor, rightColor, fraction
	
	# Bottom layer: Mix the colors WITH transition limit
	draggableBottom.backgroundColor =
		Color.mix leftColor, rightColor, fraction, yes
	
	# Make sure both layers move
	draggableTop.x = draggedLayer.x
	draggableBottom.x = draggedLayer.x
	
	# Show the current fraction on both layers
	fractionText = Utils.round fraction, 1
	draggableTopLabel.text = fractionText
	draggableBottomLabel.text = fractionText


# Top layer is being dragged 
draggableTop.onMove ->
	setMixedColors this

# Bottom layer is being dragged 
draggableBottom.onMove ->
	setMixedColors this
